public class PiEstimate {
    // This method implements Monte Carlo Pi Estimation
    // See https://www.101computing.net/estimating-pi-using-the-monte-carlo-method/
    // for an interactive example of how this works in Python
    private static double estimatePi(int radius, int numSamples) {
        int radiusSquared = radius * radius;
        int samplesInCircle = 0;

        for (int i = 0; i < numSamples; ++i) {
            double xSquared = Math.pow(Math.random() * radius, 2);
            double ySquared = Math.pow(Math.random() * radius, 2);

            if (xSquared + ySquared <= radiusSquared) {
                samplesInCircle++;
            }
        }

        return (((double) samplesInCircle / numSamples) * 4);
    }

    public static void main(String[] args) {
        System.out.println("result = " + estimatePi(10000, 2000));
    }
}